/*
    This file is part of Blobtrixd
    Copyright (C) 2004-2005 Markus Kettunen

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <stdio.h>
#include <string.h>

#include "SDL.h"
#include "SDL_net.h"

#include "variable.h"
#include "net.h"
#include "block.h"

#include "server.h"

#include "config.h"

#include <iostream>

block Block;

int main(int argc, char *argv[]) {

	if (SDL_Init(SDL_INIT_TIMER) != 0) {
		cout << "Couldn't init SDL:" << SDL_GetError() << "\n";
		exit(1);
	}

	atexit(SDL_Quit);

	srand(SDL_GetTicks());

	char *filename;

	if (argc<=1) {
		filename = new char[12];
		sprintf (filename, "server.conf");
	} else {
		filename = new char[strlen(argv[1])+1];
		strcpy (filename, argv[1]);
	}

	for (int argnum=1; argnum < argc; argnum++) {
		if (!strcmp(argv[argnum], "-h") || !strcmp(argv[argnum], "--help")) {
			cout << "Blobtrix dedicated server 1.2.1\n";
			cout << "\n";
			cout << "Usage: ./blobtrixd [configfilename]\n";
			cout << "If no config file is specified, server.conf is used.\n";
			exit(1);
		}
	}

	net::Start();

	server Server;

	Server.serve(filename);

	net::Stop();

	return(0);
}
