/*
    This file is part of Blobtrixd
    Copyright (C) 2004-2005 Markus Kettunen

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "net.h"

int net::Start(){
	if (SDLNet_Init()==-1) {
		cout << "Couldn't initialize network.\n";
		exit(0);
	}
	return 1;
}

int net::Stop(){
	SDLNet_Quit();
	return 1;
}

Uint16 net::ConvPort(Uint16 port) {
#if SDL_BYTEORDER == SDL_LIL_ENDIAN
	return (port>>8) | (port<<8);
#else
	return port;
#endif
}

bool net::SendUDPpacket(UDPsocket sock, int channel, char *data) {
	UDPpacket packet;
	packet.data = (Uint8*)data;
	packet.len = strlen(data)+1;
	if (! SDLNet_UDP_Send(sock, channel, &packet) ) {
		return 0;
	}
	return 1;
}

bool net::SendUDPpacket_unbound(UDPsocket sock, IPaddress address, char *data) {
	SDLNet_UDP_Bind(sock, SDLNET_MAX_UDPCHANNELS-1, &address);
	bool ret = SendUDPpacket(sock, SDLNET_MAX_UDPCHANNELS-1, data);
	SDLNet_UDP_Unbind(sock, SDLNET_MAX_UDPCHANNELS-1);
	return ret;
}

Uint32 net::TCP_SendMSG(TCPsocket sock, char *msg) {
	int len = strlen(msg);
	msg[len]='\r';
	msg[len+1]='\n';
	msg[len+2]='\0';
	len+=4;

	return SDLNet_TCP_Send(sock, msg, len);
}
