/*
    This file is part of Blobtrixd
    Copyright (C) 2004-2005 Markus Kettunen

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef _SERVER_H_
#define _SERVER_H_

#include "SDL.h"
#include "SDL_net.h"
#include "splayer.h"
#include "servconf.h"

#include "string.h"

#include "follower.h"

#define MAXFOLLOWERS 10


#define NICKMIN 2
#define NICKMAX 19

#define XSIZE 14
#define YSIZE 28

#define MAXMOVEDELAY 50

class server {
	public:
		server();

		void serve(char *filename);


	private:

		follower followers[MAXFOLLOWERS];

		void ContactMetaserver();
		IPaddress metaaddress;

		bool CheckNickname(char *nick);
		int FirstFreePlayerslot();
		int RecognizePlayer(IPaddress address);
		int PlayersJoined();

		void DeletePlayersBlock(int player, int i);
		void SendUpdatedPlayersBlock(int player, int i);
		void SendUpdatedPlayersSlots(int i);
		void SendScores(int i);
		void SendLines(int i);
		void SendUpdatedBlockmap();
		void SendCanShoot(int i);
		void SendWin(int i);
		void SendTime(int i);
		void SendPing(int i);

		void SendEvent(int player, int event);

		void SendWantNewgame(int i);
		void SendEverything();

		void NewGame();

		Uint32 Min2Frame(Uint32 min);

//		char *skipleft(char *str, int howmany);

		int FirstFreeFollowerslot();
		int RecognizeFollower(IPaddress address);

		void RawSendAll(char *data);



		bool requirepassword;
		char password[65];

		UDPsocket sock;
		splayer players[2];

		servconf Config;

		int newblocktime;
		int serverspeed;

		Uint32 starttime;
		int gametime;

		Uint32 pingtimetimer;
		int timestep;

		Uint32 timeupdate;
		
		int winner;

		int noshoot;

		char blocks[YSIZE][XSIZE];




};


#endif
